#include <ros/ros.h>
#include <sstream>
#include <iostream>
#include <string>
#include <std_msgs/String.h>
#include <iomanip>

std::stringstream tts_str;

void targetCallback(const std_msgs::String::ConstPtr& msg)
{
    std::istringstream org_str(msg->data);
    std::string key;
    org_str>>key;
    std::string obj_name;

    if(key == "bdc1fe0d3c84dc4e0759e7ad96004426")
    {
       obj_name="水杯";
    }
    std::string len_str;
    org_str>>len_str;
    tts_str<<"前方"<<len_str.substr(0, 3)<<"米发现"<<obj_name;
}

int main(int argc, char **argv)
{
    ros::init(argc, argv, "recognize_obj_node");
    ros::NodeHandle nh;
    ros::Subscriber sub = nh.subscribe("obj_target_topic", 10, targetCallback);
    ros::Publisher tts_pub = nh.advertise<std_msgs::String>("/voice_system/tts_topic", 10);
    std_msgs::String tts_msg;

    ros::Duration loop(2.5);
    while(ros::ok())
    {
      if(tts_str.str().length() > 0)
      {
        tts_msg.data = tts_str.str();
        tts_pub.publish(tts_msg);
        tts_str.str("");
      }
      ros::spinOnce();
      loop.sleep();
    }

    return 0;
}
